package com.loafle.overflow.module.infra.model;


import com.loafle.overflow.module.meta.model.MetaInfraType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA", schema = "public", catalog = "postgres")
public class Infra {
    private long id;
    private MetaInfraType type;
    private long childId;
    private Date createDate;

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "TYPE_ID", nullable = false)
    public MetaInfraType getType() {
        return type;
    }

    public void setType(MetaInfraType type) {
        this.type = type;
    }

    @Basic
    @Column(name = "CHILD_ID", nullable = false)
    public long getChildId() {
        return childId;
    }

    public void setChildId(long childId) {
        this.childId = childId;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }


    public static Infra CreateInfraByType(long id, Class c) {

        Infra infra = new Infra();
        infra.setChildId(id);

        MetaInfraType type = new MetaInfraType();
        if(c == InfraMachine.class) {
            type.setId(1);
        }
        else if(c == InfraHost.class) {
            type.setId(2);
        }
        else if(c == InfraOS.class) {
            type.setId(3);
        }
        else if(c == InfraOSApplication.class) {
            type.setId(4);
        }
        else if(c == InfraOSDaemon.class) {
            type.setId(5);
        }
        else if(c == InfraOSPort.class) {
            type.setId(6);
        }
        else if(c == InfraService.class) {
            type.setId(7);
        }

        infra.setType(type);

        return infra;
    }

}
